require("states/gameState/unit_data")
require("states/gameState/actions")
require("states/gameState/fighting")
require("states/gameState/enemy")

function draw_game(dt)
	
	camera:set()
	
	for x=1,world.width do
		for y=1,world.height do
			
			love.graphics.setColor(200,160,80)
			if x==sx and y==sy then love.graphics.setColor(200,0,0) end --The Pos of your warrior
			if x==ax and y==ay then love.graphics.setColor(100,80,40) end --The Pos of your selected block
			love.graphics.rectangle("fill",(x-1)*world.blocksize,(y-1)*world.blocksize,world.blocksize,world.blocksize) --The line round of the block
			love.graphics.setColor(0,200,0)
			
			if (playermode==1 and team==1) or playermode==2 then
				--the attack-area of the warrior  settings 1
				if settings.show_attacks==1 and mode=="fight" then
					if felder[x][y].area==0 or felder[x][y].area==2 then
						love.graphics.setColor(0,200,0)
					else
						love.graphics.setColor(200,0,0)
					end
				end
				--the attack-area of the warrior  settings 2
				if settings.show_attacks==2 then
					if felder[x][y].area==0 then
						love.graphics.setColor(0,200,0)
					else
						love.graphics.setColor(200,0,0)
					end
				end
			end
			
			love.graphics.rectangle("fill",(x-1)*world.blocksize+5,(y-1)*world.blocksize+5,world.blocksize-10,world.blocksize-10) --the block
			if felder[x][y].team~=0 then
				if felder[x][y].team==1 then love.graphics.setColor(0,0,200) else love.graphics.setColor(200,0,0) end
				love.graphics.rectangle("fill",(x-1)*world.blocksize+10,(y-1)*world.blocksize+10,world.blocksize-20,world.blocksize-20)
				love.graphics.setColor(0,0,0)
				love.graphics.rectangle("line",(x-1)*world.blocksize+10,(y-1)*world.blocksize+10,world.blocksize-20,world.blocksize-20)
			end
			if felder[x][y].team~=0 then
				love.graphics.setColor(255,255,255)
				love.graphics.draw(pictures["warrior_"..felder[x][y].typ],(x-1)*world.blocksize+4,(y-1)*world.blocksize+4,0,0.9)
			end
			
		end
	end
	
	draw_unit_data()
	
	camera:unset()
	
	love.graphics.setColor(100,80,50) --the things right
	love.graphics.rectangle("fill",800,0,200,800)
	love.graphics.setColor(150,120,75)
	love.graphics.rectangle("fill",800+8,0+8,200-16,800-16)
	if team==1 then	design(10,"Blue",830,30,2,0,0,255) else design(10,"Red",830,30,2,255,0,0) end
	if mode=="go" then design(1,"Go",830,90,1.7) elseif mode=="fight" then design(1,"Fight",830,90,1.7) end
	love.graphics.draw(pictures[1],810,125)
	
	if felder[ax][ay].team~=0 then
		local red,green,blue=0,0,0
		if felder[ax][ay].team==1 then red,green,blue=0,0,200 else red,green,blue=200,0,0 end
		design(1,felder[ax][ay].typ,820,195,1,red,green,blue)
		design(1,units[felder[ax][ay].typ].attack.." Attack",820,235,0.8)
		design(1,felder[ax][ay].live.." of "..units[felder[ax][ay].typ].live.." Live",820,265,0.8)
		design(1,units[felder[ax][ay].typ].foot.." Foot",820,295,0.8)
	end
	
	love.graphics.setColor(255,255,255)
	if mx>810 and mx<860 and my>730 and my<780 then love.graphics.setColor(255,100,100) end
	love.graphics.draw(pictures["icon_warrior"],810,730)
	design(3,settings.show_warriors,810+30,730+25,1.5,200,0,0)
	
	love.graphics.setColor(255,255,255)
	if mx>870 and mx<920 and my>730 and my<780 then love.graphics.setColor(255,100,100) end
	love.graphics.draw(pictures["icon_attack"],870,730)
	design(3,settings.show_attacks,870+30,730+25,1.5,200,0,0)
	
	love.graphics.setColor(255,255,255)
	if mx>930 and mx<980 and my>730 and my<780 then love.graphics.setColor(255,100,100) end
	love.graphics.draw(pictures["icon_music"],930,730)
	if settings.musik then love.graphics.draw(pictures["icon_no"],930,730) end
	
	actions_draw()
	
end

function keypressed_game(key)

	actions_keypressed(key)

	if action=="nothing" then
		if (playermode==1 and team==1) or playermode==2 then
			if team==1 then
				if key=="up" and ay>1 then ay=ay-1 end
				if key=="down" and ay<world.height then ay=ay+1 end
				if key=="left" and ax>1 then ax=ax-1 end
				if key=="right" and ax<world.width then ax=ax+1 end
			end
			if team==2 then
				if key=="w" and ay>1 then ay=ay-1 end
				if key=="s" and ay<world.height then ay=ay+1 end
				if key=="a" and ax>1 then ax=ax-1 end
				if key=="d" and ax<world.width then ax=ax+1 end
			end
			if key=="escape" then
				sx=0
				sy=0
			end
		end
		if (playermode==1 and team==1) or playermode==2 then
				if key=="return" or key==" " then
					if mode=="go" then
						if sx==0 and sy==0 then
							if felder[ax][ay].team==team then
								sx=ax
								sy=ay
							end
						elseif sx==ax and sy==ay then
							sx=ax
							sy=ay
							mode="fight"
						else
							local canreachX=sx-ax
							local canreachY=sy-ay
							if canreachX<0 then canreachX=canreachX+canreachX*-2 end
							if canreachY<0 then canreachY=canreachY+canreachY*-2 end
							local canreach=canreachX+canreachY
							if felder[ax][ay].typ==0 and felder[ax][ay].team==0 and canreach<units[felder[sx][sy].typ].foot then
								felder[ax][ay].typ=felder[sx][sy].typ
								felder[ax][ay].team=felder[sx][sy].team
								felder[ax][ay].live=felder[sx][sy].live
								felder[sx][sy].typ=0
								felder[sx][sy].team=0
								felder[sx][sy].live=0
								sx=ax
								sy=ay
								mode="fight"
							end
							sounds["running"]:stop()
							sounds["running"]:play()
						end
					elseif mode=="fight" then
						if felder[ax]~=nil and felder[ax][ay]~=nil and felder[ax][ay].area==1 then
							felder[ax][ay].live=felder[ax][ay].live-units[felder[sx][sy].typ].attack
							if team==1 then team=2 else team=1 end
							mode="go"
							sx=0
							sy=0
							sounds["fight"]:stop()
							sounds["fight"]:play()
						elseif sx==ax and sy==ay then
							if team==1 then team=2 else team=1 end
							mode="go"
							sx=0
							sy=0
						end
					end
				end
			end
		end
	end
	
	if action=="nothing" then
		if playermode==1 then
		if key=="up" and ay>1 then ay=ay-1 end
		if key=="down" and ay<world.height then ay=ay+1 end
		if key=="left" and ax>1 then ax=ax-1 end
		if key=="right" and ax<world.width then ax=ax+1 end
		if key=="w" and ay>1 then ay=ay-1 end
		if key=="s" and ay<world.height then ay=ay+1 end
		if key=="a" and ax>1 then ax=ax-1 end
		if key=="d" and ax<world.width then ax=ax+1 end
		if key=="escape" and mode=="go" then
			sx=0
			sy=0
		end
		if key=="return" or key==" " or key=="f" then
			if mode=="go" then
				if sx==0 and sy==0 then
					if felder[ax][ay].team==team then
						sx=ax
						sy=ay
					end
				elseif sx==ax and sy==ay then
					sx=ax
					sy=ay
					mode="fight"
				else
					local canreachX=sx-ax
					local canreachY=sy-ay
					if canreachX<0 then canreachX=canreachX+canreachX*-2 end
					if canreachY<0 then canreachY=canreachY+canreachY*-2 end
					local canreach=canreachX+canreachY
					if canreach<0 then canreach=canreach-canreach*2 end
					if felder[ax][ay].typ==0 and felder[ax][ay].team==0 and canreach<units[felder[sx][sy].typ].foot then
						felder[ax][ay].typ=felder[sx][sy].typ
						felder[ax][ay].team=felder[sx][sy].team
						felder[ax][ay].live=felder[sx][sy].live
						felder[sx][sy].typ=0
						felder[sx][sy].team=0
						felder[sx][sy].live=0
						sx=ax
						sy=ay
						mode="fight"
						sounds["running"]:stop()
						sounds["running"]:play()
					end
				end
			elseif mode=="fight" then
				if felder[ax]~=nil and felder[ax][ay]~=nil and felder[ax][ay].area==1 then
					felder[ax][ay].live=felder[ax][ay].live-units[felder[sx][sy].typ].attack
					if team==1 then team=2 else team=1 end
					mode="go"
					sx=0
					sy=0
					sounds["fight"]:stop()
					sounds["fight"]:play()
					timer=settings.timer
				elseif sx==ax and sy==ay then
					if team==1 then team=2 else team=1 end
					mode="go"
					sx=0
					sy=0
					timer=settings.timer
				end
			end
		end
	end

end

function mousepressed_game(x,y,button)

	if button=="l" and mx>810 and mx<860 and my>730 and my<780 then action="settings_warriors" selected=1 end
	if button=="l" and mx>870 and mx<920 and my>730 and my<780 then action="settings_fight" selected=1 end
	if button=="l" and mx>930 and mx<980 and my>730 and my<780 then
		if settings.musik==false then
			settings.musik=true
		else
			settings.musik=false
		end
	end

end

function update_game()

	reloadBlocks()
	
	if enemymode==1 then fighting() end
	
	enemy_canfight()
	enemy_fightorgo("1.")
	
	timer=timer-dt*60
	
	if ax*world.blocksize<camx+200 then camx=camx-3 end
	if ax*world.blocksize>camx+600 then camx=camx+3 end
	if ay*world.blocksize<camy+200 then camy=camy-3 end
	if ay*world.blocksize>camy+600 then camy=camy+3 end
	
	if ax*world.blocksize<camx+100 then camx=camx-6 end
	if ax*world.blocksize>camx+700 then camx=camx+6 end
	if ay*world.blocksize<camy+100 then camy=camy-6 end
	if ay*world.blocksize>camy+700 then camy=camy+6 end
	
	if ax*world.blocksize<camx+40 then camx=camx-20 end
	if ax*world.blocksize>camx+760 then camx=camx+20 end
	if ay*world.blocksize<camy+40 then camy=camy-20 end
	if ay*world.blocksize>camy+760 then camy=camy+20 end
	
	if camx<0 then camx=0 end
	if camx+800>world.width*world.blocksize then camx=world.width*world.blocksize-800 end
	if camy<0 then camy=0 end
	if camy+800>world.width*world.blocksize then camy=world.width*world.blocksize-800 end
	camera:setPosition(camx,camy)
end

function reloadBlocks()
	local team1=0
	local team2=0
	for x=1,world.width do
		for y=1,world.height do
			felder[x][y].area=0
			if felder[x][y].team==1 then team1=team1+1 end
			if felder[x][y].team==2 then team2=team2+1 end
			if felder[x][y].live<=0 and felder[x][y].team~=0 then
				if team~=0 then
					sounds["death"]:stop()
					sounds["death"]:play()
				end
				felder[x][y].team=0
				felder[x][y].typ=0
				felder[x][y].live=0
			end
		end
	end
	if team1==0 and team2~=0 then winner="red" end
	if team2==0 and team1~=0 then winner="blue" end
	if team2==0 and team1==0 then winner="nobody" end
	if winner~=" " then state="gameover" press=30
	end
end